from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, File, Boolean

Anvi_Experimental_Organization_V0_1_0 = CommandToolBuilder(tool="anvi_experimental_organization", base_command=["anvi-experimental-organization"], inputs=[ToolInput(tag="in_profile_db", input_type=String(optional=True), prefix="--profile-db", doc=InputDocumentation(doc="Anvi'o profile database")), ToolInput(tag="in_contigs_db", input_type=String(optional=True), prefix="--contigs-db", doc=InputDocumentation(doc="Anvi'o contigs database generated by 'anvi-gen-\ncontigs'")), ToolInput(tag="in_input_directory", input_type=File(optional=True), prefix="--input-directory", doc=InputDocumentation(doc="Input directory where the input files addressed from\nthe configuration file can be found (i.e., the profile\ndatabase, if PROFILE.db::TABLE notation is used in the\nconfiguration file).")), ToolInput(tag="in_name", input_type=String(optional=True), prefix="--name", doc=InputDocumentation(doc="The name to use when storing the resulting clustering\nin the database. This name will appear in the\ninteractive interface and other relevant interfaces.\nPlease consider using a short and descriptive single-\nword (if you do not do that you will make anvi'o\ncomplain).")), ToolInput(tag="in_distance", input_type=File(optional=True), prefix="--distance", doc=InputDocumentation(doc="The distance metric for the hierarchical clustering.\nIf you do not use this flag, the distance metric you\ndefined in your clustering config file will be used.\nIf you have not defined one in your config file, then\nthe system default will be used, which is 'euclidean'.")), ToolInput(tag="in_linkage", input_type=String(optional=True), prefix="--linkage", doc=InputDocumentation(doc="Same story with the `--distance`, except, the system\ndefault for this one is ward.")), ToolInput(tag="in_skip_store_in_db", input_type=Boolean(optional=True), prefix="--skip-store-in-db", doc=InputDocumentation(doc="By default, analysis results are stored in the profile\ndatabase. The use of this flag will let you skip that")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--output-file", doc=InputDocumentation(doc="File path to store results.")), ToolInput(tag="in_dry_run", input_type=Boolean(optional=True), prefix="--dry-run", doc=InputDocumentation(doc="Don't do anything real. Test everything, and stop\nright before wherever the developer said 'well, this\nis enough testing', and decided to print out results.\n"))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="File path to store results."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Experimental_Organization_V0_1_0().translate("wdl", allow_empty_container=True)

